import sys
import time
import numpy as np
import json

from ortools.sat.python import cp_model

def solve(pidx, num_colors):
  # Create model
  model = cp_model.CpModel()

  # variables
  washington = model.NewIntVar(1, num_colors, "washington")
  montana = model.NewIntVar(1, num_colors, "montana")
  maine = model.NewIntVar(1, num_colors, "maine")
  north_dakota = model.NewIntVar(1, num_colors, "north_dakota")
  south_dakota = model.NewIntVar(1, num_colors, "south_dakota")
  wyoming = model.NewIntVar(1, num_colors, "wyoming")
  wisconsin = model.NewIntVar(1, num_colors, "wisconsin")
  idaho = model.NewIntVar(1, num_colors, "idaho")
  vermont = model.NewIntVar(1, num_colors, "vermont")
  minnesota = model.NewIntVar(1, num_colors, "minnesota")
  oregon = model.NewIntVar(1, num_colors, "oregon")
  new_hampshire = model.NewIntVar(1, num_colors, "new_hampshire")
  iowa = model.NewIntVar(1, num_colors, "iowa")
  massachusetts = model.NewIntVar(1, num_colors, "massachusetts")
  nebraska = model.NewIntVar(1, num_colors, "nebraska")
  new_york = model.NewIntVar(1, num_colors, "new_york")
  pennsylvania = model.NewIntVar(1, num_colors, "pennsylvania")
  connecticut = model.NewIntVar(1, num_colors, "connecticut")
  rhode_island = model.NewIntVar(1, num_colors, "rhode_island")
  new_jersey = model.NewIntVar(1, num_colors, "new_jersey")
  indiana = model.NewIntVar(1, num_colors, "indiana")
  nevada = model.NewIntVar(1, num_colors, "nevada")
  utah = model.NewIntVar(1, num_colors, "utah")
  california = model.NewIntVar(1, num_colors, "california")
  ohio = model.NewIntVar(1, num_colors, "ohio")
  illinois = model.NewIntVar(1, num_colors, "illinois")
  washington_dc = model.NewIntVar(1, num_colors, "washington_dc")
  delaware = model.NewIntVar(1, num_colors, "delaware")
  west_virginia = model.NewIntVar(1, num_colors, "west_virginia")
  maryland = model.NewIntVar(1, num_colors, "maryland")
  colorado = model.NewIntVar(1, num_colors, "colorado")
  kentucky = model.NewIntVar(1, num_colors, "kentucky")
  kansas = model.NewIntVar(1, num_colors, "kansas")
  virginia = model.NewIntVar(1, num_colors, "virginia")
  missouri = model.NewIntVar(1, num_colors, "missouri")
  arizona = model.NewIntVar(1, num_colors, "arizona")
  oklahoma = model.NewIntVar(1, num_colors, "oklahoma")
  north_carolina = model.NewIntVar(1, num_colors, "north_carolina")
  tennessee = model.NewIntVar(1, num_colors, "tennessee")
  texas = model.NewIntVar(1, num_colors, "texas")
  new_mexico = model.NewIntVar(1, num_colors, "new_mexico")
  alabama = model.NewIntVar(1, num_colors, "alabama")
  mississippi = model.NewIntVar(1, num_colors, "mississippi")
  georgia = model.NewIntVar(1, num_colors, "georgia")
  south_carolina = model.NewIntVar(1, num_colors, "south_carolina")
  arkansas = model.NewIntVar(1, num_colors, "arkansas")
  louisiana = model.NewIntVar(1, num_colors, "louisiana")
  florida = model.NewIntVar(1, num_colors, "florida")
  michigan = model.NewIntVar(1, num_colors, "michigan")

 
  model.Add(washington != oregon)
  model.Add(washington != idaho)
  model.Add(oregon != idaho)
  model.Add(oregon != nevada)
  model.Add(oregon != california)
  model.Add(california != nevada)
  model.Add(california != arizona)
  model.Add(nevada != idaho)
  model.Add(nevada != utah)
  model.Add(nevada != arizona)
  model.Add(idaho != montana)
  model.Add(idaho != wyoming)
  model.Add(idaho != utah)
  model.Add(utah != wyoming)
  model.Add(utah != colorado)
  model.Add(utah != new_mexico)
  model.Add(utah != arizona)
  model.Add(arizona != colorado)
  model.Add(arizona != new_mexico)
  model.Add(montana != north_dakota)
  model.Add(montana != south_dakota)
  model.Add(montana != wyoming)
  model.Add(wyoming != south_dakota)
  model.Add(wyoming != nebraska)
  model.Add(wyoming != colorado)
  model.Add(colorado != nebraska)
  model.Add(colorado != kansas)
  model.Add(colorado != oklahoma)
  model.Add(colorado != new_mexico)
  model.Add(new_mexico != oklahoma)
  model.Add(new_mexico != texas)
  model.Add(north_dakota != minnesota)
  model.Add(north_dakota != south_dakota)
  model.Add(south_dakota != minnesota)
  model.Add(south_dakota != iowa)
  model.Add(south_dakota != nebraska)
  model.Add(nebraska != iowa)
  model.Add(nebraska != missouri)
  model.Add(nebraska != kansas)
  model.Add(kansas != missouri)
  model.Add(kansas != oklahoma)
  model.Add(oklahoma != arkansas)
  model.Add(oklahoma != texas)
  model.Add(texas != arkansas)
  model.Add(texas != louisiana)
  model.Add(minnesota != wisconsin)
  model.Add(minnesota != iowa)
  model.Add(iowa != wisconsin)
  model.Add(iowa != illinois)
  model.Add(iowa != missouri)
  model.Add(missouri != illinois)
  model.Add(missouri != kentucky)
  model.Add(missouri != tennessee)
  model.Add(missouri != arkansas)
  model.Add(arkansas != tennessee)
  model.Add(arkansas != mississippi)
  model.Add(arkansas != louisiana)
  model.Add(louisiana != mississippi)
  model.Add(wisconsin != illinois)
  model.Add(wisconsin != michigan)
  model.Add(illinois != indiana)
  model.Add(illinois != kentucky)
  model.Add(kentucky != indiana)
  model.Add(kentucky != ohio)
  model.Add(kentucky != west_virginia)
  model.Add(kentucky != virginia)
  model.Add(kentucky != tennessee)
  model.Add(tennessee != virginia)
  model.Add(tennessee != north_carolina)
  model.Add(tennessee != georgia)
  model.Add(tennessee != alabama)
  model.Add(tennessee != mississippi)
  model.Add(mississippi != alabama)
  model.Add(michigan != indiana)
  model.Add(michigan != ohio)
  model.Add(indiana != ohio)
  model.Add(alabama != georgia)
  model.Add(alabama != florida)
  model.Add(ohio != pennsylvania)
  model.Add(ohio != west_virginia)
  model.Add(maine != new_hampshire)
  model.Add(new_hampshire != vermont)
  model.Add(new_hampshire != massachusetts)
  model.Add(vermont != massachusetts)
  model.Add(vermont != new_york)
  model.Add(massachusetts != new_york)
  model.Add(massachusetts != rhode_island)
  model.Add(massachusetts != connecticut)
  model.Add(connecticut != rhode_island)
  model.Add(new_york != connecticut)
  model.Add(new_york != pennsylvania)
  model.Add(new_york != new_jersey)
  model.Add(pennsylvania != new_jersey)
  model.Add(pennsylvania != delaware)
  model.Add(pennsylvania != maryland)
  model.Add(pennsylvania != west_virginia)
  model.Add(new_jersey != delaware)
  model.Add(maryland != washington_dc)
  model.Add(maryland != west_virginia)
  model.Add(maryland != virginia)
  model.Add(washington_dc != virginia)
  model.Add(west_virginia != virginia)
  model.Add(virginia != north_carolina)
  model.Add(north_carolina != south_carolina)
  model.Add(south_carolina != georgia)
  model.Add(georgia != florida)

  states = [washington,montana,maine,north_dakota,south_dakota,wyoming,wisconsin,idaho,vermont,minnesota,oregon,new_hampshire,
    iowa,massachusetts,nebraska,new_york,pennsylvania,connecticut,rhode_island,new_jersey,indiana,nevada,utah,california,ohio,
    illinois,washington_dc,delaware,west_virginia,maryland,colorado,kentucky,kansas,virginia,missouri,arizona,oklahoma,north_carolina,
    tennessee,texas,new_mexico,alabama,mississippi,georgia,south_carolina,arkansas,louisiana,florida,michigan]

  max_color = model.NewIntVar(1, num_colors, "max_color")

  model.AddMaxEquality(max_color, states)

  model.Minimize(max_color)

  # search and solution
  solver = cp_model.CpSolver()
  status = solver.Solve(model)
  print(str(pidx)+",",solver.WallTime())

  if status == cp_model.OPTIMAL:
    print('Minimum of objective function: %i' % solver.ObjectiveValue())
    print()
    for state in states:
      print(solver.Value(state))

if __name__ == "__main__":
  i = 0
  for num_colors in [3,4,8,20]:
	  solve(i, num_colors)
	  i += 1